/**
 * Copyright harada ( http://wonderfl.net/user/harada )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/uWqH
 */

// forked from sekiryou's 灯籠流し
// forked from Event's Simple MediaRSS Viewer
/**
* 灯籠流し
* Wikipedia - Tōrō nagashi
* http://en.wikipedia.org/wiki/T%C5%8Dr%C5%8D_nagashi
* 
* @author Masayuki Komatsu
* http://sekiryou.com/
* http://twitter.com/sekiryou_com
*/
package {
    import flash.system.Security;
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.Graphics;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.IOErrorEvent;
    import flash.events.KeyboardEvent;
    import flash.events.MouseEvent;
    import flash.geom.Matrix;
    import flash.geom.Matrix3D;
    import flash.geom.PerspectiveProjection;
    import flash.geom.Utils3D;
    import flash.geom.Vector3D;
    import flash.text.TextField;
    import flash.text.TextFieldType;
    import flash.text.TextFormat;
    import flash.geom.Rectangle;
    import flash.display.GradientType;
    import flash.display.SpreadMethod;
    import flash.display.Shape;
    import flash.display.Loader;
    import flash.system.LoaderContext;
    import flash.net.URLRequest;
    import flash.net.URLLoader;
    
    import caurina.transitions.Tweener;
    
    [SWF(width = 465, height = 465, backgroundColor = 0x000000, frameRate = 30)]
    
    public class TourouNagashi extends Sprite {
        private const DEGREE_TO_RADIAN:Number = Math.PI / 180;
        private const TOTAL_TOUROU:int = 20;
        private var projection:PerspectiveProjection;
        private var projectionMatrix3D:Matrix3D;
        private var mtx3D:Matrix3D = new Matrix3D();
        private var projectedVerts:Vector.<Number> = new Vector.<Number>();
        private var vertexList:Vector.<Number> = new Vector.<Number>();
        private var indexList:Vector.<int> = new Vector.<int>();
        private var uvtList:Vector.<Number> = new Vector.<Number>();
        
        private var tourouList:Vector.<Tourou> = new Vector.<Tourou>();
        private var tCloneList:Vector.<Tourou> = new Vector.<Tourou>();
        private var kyouzouList:Vector.<Kyouzou> = new Vector.<Kyouzou>();
        private var kCloneList:Vector.<Kyouzou> = new Vector.<Kyouzou>();
        private var minamo:Minamo;
        
        private var mtrx:Matrix = new Matrix();
        private var screen:Sprite = new Sprite();
        private var texture:BitmapData
        
        public function TourouNagashi() {
            var capture:Bitmap = new Bitmap(new BitmapData(465, 465, false, 0x000000));
            addChild(capture);
            
            init();
        }
        
        private var exCoodMap:Array;
        private var exCoodMapW:int = 20;
        private var exCoodMapH:int = 20;
        private var exCoodRate:int = 100;
        private function exCoodMapper():void {
            exCoodMap = [];
            for (var i:int = 0; i < exCoodMapW * exCoodMapW; i++) {
                exCoodMap.push([]);
            }
        }
        
        private function init():void {
            stage.quality ="medium";
            projection = new PerspectiveProjection();
            projection.fieldOfView = 40;
            projectionMatrix3D = projection.toMatrix3D();
            screen = new Sprite();
            addChild(screen);
            screen.x = 233;
            screen.y = 233 - 160;
            
            var tmpShape:Shape = new Shape();
            mtrx.createGradientBox(100, 100, -3.1415926 / 2, 0, 0);
            var spreadMethod:String = SpreadMethod.PAD;
            tmpShape.graphics.beginGradientFill(GradientType.LINEAR, [0x000000, 0x000000], [0.0, 1.0], [0x00, 0xFF], mtrx);
            tmpShape.graphics.drawRect(0, 0, 500, 100);
            
            var textureSize:Number = 1000;
            texture = new BitmapData(textureSize, textureSize, true, 0x00000000);
            texture.draw(new BitmapData(textureSize, textureSize * 0.5, true, 0xFF996600));
            //Minamo
            var surface:BitmapData = new BitmapData(textureSize * 0.5, textureSize * 0.5, true, 0x000000);
            surface.perlinNoise(128, 8, 4, Math.floor( Math.random() * 0x0000FF ), false, true, 0 | 0 | 0 | 8);
            mtrx.a = 1;
            mtrx.b = 0;
            mtrx.c = 0;
            mtrx.d = 1;
            mtrx.tx = 0;
            mtrx.ty = textureSize * 0.5;
            texture.fillRect(new Rectangle(0, textureSize * 0.5, textureSize * 0.5, textureSize * 0.5), 0x66003311);
            texture.draw(surface, mtrx, null, "normal");
            texture.draw(tmpShape, mtrx, null, "normal");
            
            mtrx.a = 1;
            mtrx.b = 0;
            mtrx.c = 0;
            mtrx.d = 1;
            mtrx.tx = textureSize * 0.5-10;
            mtrx.ty = textureSize * 0.5-10;
            texture.draw(new BitmapData(100, 100, false, 0x302000), mtrx);
            
            var posMap:Array = [];
            const posMapW:int = 10;
            const posMapH:int = 6;
            for (var i:int = 0; i < posMapW * posMapH; i++ ) {
                posMap.push(i);
            }
            posMap.sort(function():int { return Math.random() > 0.5 ? 1 : -1; } );
            
            exCoodMapper();
            var rate:Number = 100;
            //TourouGenerate
            for (i = 0; i < TOTAL_TOUROU; i++ ) {
                var tmp:Tourou = new Tourou(i % 10 * 0.1, (i % 10 + 1) * 0.1, int(i * 0.1) * 0.1, (int(i * 0.1) + 1) * 0.1);
                screen.addChild(tmp);
                tmp.buttonMode = true;
                tmp.addEventListener(MouseEvent.CLICK, tourouClick);
                tourouList.push(tmp);
                tmp.id = i;
                tmp.px = (posMap[i] % posMapW - posMapW * 0.5) * rate + 200;
                tmp.pz = (int(posMap[i] / posMapW) - posMapH * 0.5) * rate;
                tmp.vx = Math.random() * -0.8 - 0.4;
                tmp.vz = Math.random() * 0.8 - 0.4;
                
                var tx:Number = exCoodMapW * 0.5 * exCoodRate + tmp.px;
                var tz:Number = exCoodMapH * 0.5 * exCoodRate - tmp.pz;
                var trn:int = int(tz / exCoodRate) * exCoodMapH + int(tx / exCoodRate);
                
                exCoodMap[trn].push(i);
                tmp.registId = trn;
                tmp.collisionCheck = true;
            }
            
            //KyouzouGenerate
            for (i = 0; i < TOTAL_TOUROU; i++ ) {
                var tmp2:Kyouzou = new Kyouzou(i % 10 * 0.1, (i % 10 + 1) * 0.1, int(i * 0.1) * 0.1, (int(i * 0.1) + 1) * 0.1);
                kyouzouList.push(tmp2);
                tmp2.collisionCheck = false;
            }
            //MinamoGenerate
            minamo = new Minamo();
            minamo.collisionCheck = false;
            
            MediaRSSReader();
            thumbContainer = new Sprite();
            thumbContainer.y = -110;
            addChild(thumbContainer);
            
            controlPanel();
            viewerInit();
            thumbLoadInit();
            
            back.alpha = backAlpha = 1;
            thumbLoadStart();
            
            var maskSizeX:Number = 2400;
            var maskSizeY:Number = 1200;
            var shape:Shape = new Shape();
            shape.graphics.beginFill(0x000000);
            shape.graphics.drawRect(maskSizeX * -0.5 + 465 * 0.5, maskSizeY * -0.5 + 465 * 0.5, maskSizeX, maskSizeY);
            shape.graphics.drawRect(0, 0, 465, 465);
            shape.graphics.endFill();
            addChild(shape);
        }
        private var sortedVertices:Vector.<Number> = new Vector.<Number>();
        private var tmpIndices:Vector.<int> = new Vector.<int>();
        private var tmpUvts:Vector.<Number> = new Vector.<Number>();
        private var offsetX:Number = 0;
        private var offsetY:Number = 160;
        private var offsetZ:Number = 640;
        private var rotX:Number = 0;
        private var rotY:Number = 0;
        private var rotZ:Number = 0;
        private var cnt:Number = 0;
        private var tmpPolyList:Vector.<Polygon> = new Vector.<Polygon>();
        private function update(e:Event = null):void {
            var i:int
            var j:int
            var len:int;
            
            vertexList.length = 0;
            tCloneList.length = 0;
            kCloneList.length = 0;
            len = tourouList.length;
            for (i = 0; i < len; i++) {
                tourouList[i].cameraVertices.length = 0;
                var virtualPx:Number = tourouList[i].px + tourouList[i].vx;
                var virtualPz:Number = tourouList[i].pz + tourouList[i].vz;
                
                if (tourouList[i].collisionCheck) {
                    tx = exCoodMapW * 0.5 * exCoodRate + virtualPx;
                    tz = exCoodMapH * 0.5 * exCoodRate - virtualPz;
                    trn = int(tz / exCoodRate) * exCoodMapH + int(tx / exCoodRate);
                    
                    //注 - 範囲外処理なし
                    var tmpTag:Array = [trn];
                    tmpTag.push(int(tz / exCoodRate) * exCoodMapH + int(tx / exCoodRate) - 1);
                    tmpTag.push(int(tz / exCoodRate - 1) * exCoodMapH + int(tx / exCoodRate) - 1);
                    tmpTag.push(int(tz / exCoodRate + 1) * exCoodMapH + int(tx / exCoodRate) - 1);
                    tmpTag.push(int(tz / exCoodRate) * exCoodMapH + int(tx / exCoodRate) + 1);
                    tmpTag.push(int(tz / exCoodRate - 1) * exCoodMapH + int(tx / exCoodRate) + 1);
                    tmpTag.push(int(tz / exCoodRate + 1) * exCoodMapH + int(tx / exCoodRate) + 1);
                    tmpTag.push(int(tz / exCoodRate - 1) * exCoodMapH + int(tx / exCoodRate));
                    tmpTag.push(int(tz / exCoodRate + 1) * exCoodMapH + int(tx / exCoodRate));
                    
                    if (virtualPz < -400) {
                        tourouList[i].vx  = Math.random() * -0.8 - 0.4;
                        tourouList[i].vz = Math.random() * 0.4;
                        tourouList[i].ty =  Math.random() * 2 - 1;
                    } else if (virtualPz > 400) {
                        tourouList[i].vx  = Math.random() * -0.8 - 0.4;
                        tourouList[i].vz = Math.random() * -0.4;
                        tourouList[i].ty =  Math.random() * 2 - 1;
                    }
                    
                    var tagLen:int = tmpTag.length;
                    for (var k:int = 0; k < tagLen; k++) {
                        ecLen = exCoodMap[tmpTag[k]].length;
                        for (j = 0; j < ecLen; j++) {
                            var isHis:Boolean = false;
                            if (exCoodMap[tmpTag[k]][j] != i) {
                                var dx:Number = virtualPx - tourouList[exCoodMap[tmpTag[k]][j]].px;
                                var dz:Number = virtualPz - tourouList[exCoodMap[tmpTag[k]][j]].pz;
                                var dist:Number = Math.sqrt(dx * dx + dz * dz);
                                if (dist < tourouList[i].radius + tourouList[exCoodMap[tmpTag[k]][j]].radius) {
                                    var angle:Number = Math.atan2(dx, dz);
                                    virtualPz += Math.cos(angle) * (tourouList[i].radius + tourouList[exCoodMap[tmpTag[k]][j]].radius - dist) * 1;
                                    virtualPx += Math.sin(angle) * (tourouList[i].radius + tourouList[exCoodMap[tmpTag[k]][j]].radius - dist) * 1;
                                    
                                    tourouList[i].vx  = Math.random() * -0.8 - 0.4;
                                    tourouList[i].vz = Math.random() * 0.8 - 0.4;
                                    tourouList[i].ty =  Math.random() * 2 - 1;
                                    break;
                                }
                            }
                            if (isHis) break;
                        }
                    }
                    
                    tourouList[i].px = virtualPx;
                    tourouList[i].pz = virtualPz;
                    tourouList[i].ry += tourouList[i].ty;
                    
                    //
                    var tx:Number = exCoodMapW * 0.5 * exCoodRate + tourouList[i].px;
                    var tz:Number = exCoodMapH * 0.5 * exCoodRate - tourouList[i].pz;
                    var tr:Number = 500;
                    if (tx < tr) {
                        tourouList[i].px += -tr * 2 + 2000;
                        trn = int(tz / exCoodRate) * exCoodMapH + int(tourouList[i].px / exCoodRate);
                    } else {
                        var trn:int = int(tz / exCoodRate) * exCoodMapH + int(tx / exCoodRate);
                    }
                    if (tourouList[i].registId != trn) {
                        var ecLen:int = exCoodMap[tourouList[i].registId].length;
                        for (j = 0; j < ecLen; j++) {
                            if (exCoodMap[tourouList[i].registId][j] == i) {
                                exCoodMap[tourouList[i].registId].splice(j, 1);
                                break;
                            }
                        }
                        exCoodMap[trn].push(i);
                        tourouList[i].registId = trn;
                    }
                }
                
                mtx3D.identity();
                mtx3D.appendRotation(tourouList[i].ry, Vector3D.Y_AXIS);
                mtx3D.appendTranslation(virtualPx, 0, virtualPz);
                
                mtx3D.appendTranslation(offsetX, offsetY, offsetZ);
                bugfix(mtx3D);
                mtx3D.transformVectors(tourouList[i].vertices, tourouList[i].cameraVertices);
                mtx3D.transformVectors(kyouzouList[i].vertices, kyouzouList[i].cameraVertices);
                
                kyouzouList[i].c = tourouList[i].c = tourouList[i].cameraVertices[2];
                kyouzouList[i].px = tourouList[i].px;
                kyouzouList[i].pz = tourouList[i].pz;
                kyouzouList[i].ry = tourouList[i].ry;
                
                if (tourouList[i].cameraVertices[2] > offsetZ - 600) {
                    tCloneList.push(tourouList[i]);
                    kCloneList.push(kyouzouList[i]);
                }
            }
            
            mtx3D.identity();
            mtx3D.appendTranslation(offsetX, offsetY, offsetZ);
            bugfix(mtx3D);
            mtx3D.transformVectors(minamo.vertices, minamo.cameraVertices);
            
            tCloneList.sort(
                function(p1:Object, p2:Object):Number {
                    return p2.c - p1.c;
                }
            );
            
            kCloneList.sort(
                function(p1:Object, p2:Object):Number {
                    return p2.c - p1.c;
                }
            );
            
            var g:Graphics = screen.graphics;
            g.clear();
            //KyouzouRender
            len = kCloneList.length;
            for (i = 0; i < len; i++) {
                tmpIndices.length = 0;
                tmpUvts.length = 0;
                sortedVertices.length = 0;
                projectedVerts.length = 0;
                
                len2 = kCloneList[i].polygonList.length;
                for (j = 0; j < len2; j++) {
                    i0z = kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i0 * 3 + 2 >> 0];
                    i1z = kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i1 * 3 + 2 >> 0];
                    i2z = kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i2 * 3 + 2 >> 0];
                    kCloneList[i].polygonList[j].c = i0z;
                    if (kCloneList[i].polygonList[j].c < i1z) {
                        kCloneList[i].polygonList[j].c = i1z;
                    }
                    if (kCloneList[i].polygonList[j].c < i2z) {
                        kCloneList[i].polygonList[j].c = i2z;
                    }
                    
                }
                
                kCloneList[i].polygonList.sort(
                    function(p1:Polygon, p2:Polygon):Number {
                        return p2.c - p1.c;
                    }
                );
                
                len2 = kCloneList[i].polygonList.length;
                for (j = 0; j < len2; j++) {
                    tmpUvts.push(
                        kCloneList[i].polygonList[j].u0,
                        kCloneList[i].polygonList[j].v0,
                        null,
                        kCloneList[i].polygonList[j].u1,
                        kCloneList[i].polygonList[j].v1,
                        null,
                        kCloneList[i].polygonList[j].u2,
                        kCloneList[i].polygonList[j].v2,
                        null
                    );
                    sortedVertices.push(
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i0 * 3 + 0 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i0 * 3 + 1 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i0 * 3 + 2 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i1 * 3 + 0 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i1 * 3 + 1 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i1 * 3 + 2 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i2 * 3 + 0 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i2 * 3 + 1 >> 0],
                        kCloneList[i].cameraVertices[kCloneList[i].polygonList[j].i2 * 3 + 2 >> 0]
                    );
                }
                
                mtx3D.identity();
                mtx3D.append(projectionMatrix3D);
                bugfix(mtx3D);
                Utils3D.projectVectors(mtx3D, sortedVertices, projectedVerts, tmpUvts);
                
                g.beginBitmapFill(texture);
                g.drawTriangles(projectedVerts, null, tmpUvts, "negative");
                g.endFill();
            }
            
            //MinamoRender
            tmpUvts.length = 0;
            projectedVerts.length = 0;
            tmpUvts = tmpUvts.concat(minamo.uvts);
            
            mtx3D.identity();
            mtx3D.append(projectionMatrix3D);
            bugfix(mtx3D);
            Utils3D.projectVectors(mtx3D, minamo.cameraVertices, projectedVerts, tmpUvts);
            
            g.beginBitmapFill(texture);
            g.drawTriangles(projectedVerts, null, tmpUvts, "negative");
            g.endFill();
            
            //TourouRender
            len = tCloneList.length;
            for (i = 0; i < len; i++) {
                tmpIndices.length = 0;
                tmpUvts.length = 0;
                sortedVertices.length = 0;
                projectedVerts.length = 0;
                
                var len2:int = tCloneList[i].polygonList.length;
                for (j = 0; j < len2; j++) {
                    var i0x:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 0 >> 0];
                    var i0y:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 1 >> 0];
                    var i0z:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 2 >> 0];
                    var i1x:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 0 >> 0];
                    var i1y:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 1 >> 0];
                    var i1z:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 2 >> 0];
                    var i2x:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 0 >> 0];
                    var i2y:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 1 >> 0];
                    var i2z:Number = tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 2 >> 0];
                    
                    tCloneList[i].polygonList[j].c = i0x * i0x + i0y * i0y + i0z * i0z;
                    var tmp:Number = i1x * i1x + i1y * i1y + i1z * i1z;
                    if (tCloneList[i].polygonList[j].c < tmp) {
                        tCloneList[i].polygonList[j].c = tmp;
                    }
                    tmp = i2x * i2x + i2y * i2y + i2z * i2z;
                    if (tCloneList[i].polygonList[j].c < tmp) {
                        tCloneList[i].polygonList[j].c = tmp;
                    }
                }
                
                tCloneList[i].polygonList.sort(
                    function(p1:Polygon, p2:Polygon):Number {
                        return p2.c - p1.c;
                    }
                );
                
                len2 = tCloneList[i].polygonList.length;
                for (j = 0; j < len2; j++) {
                    tmpUvts.push(
                        tCloneList[i].polygonList[j].u0,
                        tCloneList[i].polygonList[j].v0,
                        null,
                        tCloneList[i].polygonList[j].u1,
                        tCloneList[i].polygonList[j].v1,
                        null,
                        tCloneList[i].polygonList[j].u2,
                        tCloneList[i].polygonList[j].v2,
                        null
                    );
                    sortedVertices.push(
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 0 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 1 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i0 * 3 + 2 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 0 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 1 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i1 * 3 + 2 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 0 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 1 >> 0],
                        tCloneList[i].cameraVertices[tCloneList[i].polygonList[j].i2 * 3 + 2 >> 0]
                    );
                }
                
                mtx3D.identity();
                mtx3D.append(projectionMatrix3D);
                bugfix(mtx3D);
                Utils3D.projectVectors(mtx3D, sortedVertices, projectedVerts, tmpUvts);
                
                screen.setChildIndex(tCloneList[i], i);
                
                g = tCloneList[i].graphics;
                g.clear();
                g.beginBitmapFill(texture);
                g.drawTriangles(projectedVerts, null, tmpUvts, "negative");
                g.endFill();
            }
        }
        private function bugfix(matrix:Matrix3D):void {
            var m1:Matrix3D = new Matrix3D(Vector.<Number>([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0]));
            var m2:Matrix3D = new Matrix3D(Vector.<Number>([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0]));
            m1.append( m2 );
            if (m1.rawData[15] == 20) {
                var rawData:Vector.<Number> = matrix.rawData;
                rawData[15] /= 20;
                matrix.rawData = rawData;
            }
        }
        
        //--
        private var urlList:Array;
        private var typeList:Array;
        private var thumbList:Array;
        private var thumbContainer:Sprite;
        private var urlListBackup:Array;
        private var typeListBackup:Array;
        private var _feed:String = "http://api.flickr.com/services/feeds/photos_public.gne?format=rss_200&tags=";
        private var media:Namespace = new Namespace("http://search.yahoo.com/mrss/");
        private function MediaRSSReader():void {
            //Security.loadPolicyFile("http://api.flickr.com/crossdomain.xml");
            //Security.loadPolicyFile("http://farm1.static.flickr.com/crossdomain.xml");
            //Security.loadPolicyFile("http://farm2.static.flickr.com/crossdomain.xml");
            //Security.loadPolicyFile("http://farm3.static.flickr.com/crossdomain.xml");
            //Security.loadPolicyFile("http://farm4.static.flickr.com/crossdomain.xml");
            //Security.loadPolicyFile("http://farm5.static.flickr.com/crossdomain.xml");
            
            var ldr:URLLoader = new URLLoader();
            ldr.addEventListener(Event.COMPLETE, function _load(e:Event):void {
                ldr.removeEventListener(Event.COMPLETE, _load);
                urlList = XML(ldr.data)..media::content.@url.toXMLString().split('\n');
                typeList = XML(ldr.data)..media::content.@type.toXMLString().split('\n');
                onImageLoaded(XML(ldr.data)..media::thumbnail.@url.toXMLString().split('\n'));
            });
            ldr.load(new URLRequest(_feed + encodeURIComponent(keyword)));
            removeEventListener(Event.ENTER_FRAME, update);
        }
        private function onImageLoaded($images:Array):void {
            thumbList = [];
            var ldr:Array = [];
            var compCheck:int = 0;
            var len:int = $images.length;
            if (len >= 20) { 
                for (var i:int = 0; i < 20; ++i) {
                    ldr[i] = new Loader;
                    ldr[i].load(new URLRequest($images[i]), new LoaderContext(true));
                    ldr[i].x = i;
                    
                    var thumb:Thumbnail = new Thumbnail(i);
                    thumb.buttonMode = true;
                    thumb.addEventListener(MouseEvent.CLICK, thumbnailClick)
                    thumb.addChild(ldr[i]);
                    thumbList.push(thumb);
                    thumbContainer.addChild(thumb);
                    ldr[i].contentLoaderInfo.addEventListener(Event.COMPLETE, function _load(e:Event):void {
                        e.currentTarget.removeEventListener(Event.COMPLETE, _load);
                        var tag:Loader = e.currentTarget.loader;
                        var tmpID:Number = tag.x;
                        var orgBmd:BitmapData = new BitmapData(tag.width, tag.height, false, 0x000000);
                        orgBmd.draw(tag);
                        
                        tag.y = int(tmpID * 0.1) * 100;
                        tag.x = tmpID % 10 * 100;
                        texture.draw(textureProcess(orgBmd), new Matrix(1, 0, 0, 1, tag.x, tag.y));
                        
                        tag.x = tmpID % 10 * 46.5 + 1.5;
                        tag.y = int(tmpID *0.1) * 46.5 + 1.5;
                        tag.width = 43;
                        tag.height = 43;
                        
                        compCheck += 1;
                    });
                }
                urlListBackup = [];
                typeListBackup = [];
                urlListBackup = urlListBackup.concat(urlList);
                typeListBackup = typeListBackup.concat(typeList);
            } else {
                thumbLoadIOError();
            }
            
            addEventListener(
                Event.ENTER_FRAME, function _loadObserver(e:Event):void {
                    if ($images.length == compCheck) {
                        e.currentTarget.removeEventListener(Event.ENTER_FRAME, _loadObserver);
                        
                        back.alpha = backAlpha = 1;
                        thumbLoadFinish();
                        addEventListener(Event.ENTER_FRAME, update);
                    }
                }
            );
        }
        private function textureProcess(bmd:BitmapData):BitmapData {
            var processedBmd:BitmapData = new BitmapData(100, 100, false, 0xFFFFFF);
            const REGULAR_SIZE:Number = 90;
            
            mtrx.identity();
            mtrx.scale(REGULAR_SIZE / bmd.width, REGULAR_SIZE / bmd.height);
            mtrx.translate(5, 5);
            processedBmd.draw(bmd, mtrx);
            
            //light
            var width:Number = 100;
            var tmpShape:Shape = new Shape();
            mtrx.createGradientBox(width, width, 0, 0, 20);
            var spreadMethod:String = SpreadMethod.PAD;
            tmpShape.graphics.beginGradientFill(GradientType.RADIAL, [0xFFCC99, 0xCC6600], [0.6, 0.2], [0x00, 0xFF], mtrx);
            tmpShape.graphics.drawRect(0, 0, width, width);
            
            //frame
            processedBmd.fillRect(new Rectangle(0, 0, 100, 5), 0x000000);
            processedBmd.fillRect(new Rectangle(0, 95, 100, 5), 0x000000);
            processedBmd.fillRect(new Rectangle(0, 5, 5, 90), 0x000000);
            processedBmd.fillRect(new Rectangle(95, 5, 5, 90), 0x000000);
            
            processedBmd.draw(tmpShape, null, null, "add");
            //processedBmd.draw(tmpShape, null, null, "hardlight");
            
            return processedBmd;
        }
         private function tourouClick(e:MouseEvent):void {
            var thumbID:int = e.currentTarget.id;
            if (typeList[thumbID] == "image/jpeg") {
                imageViewer(urlList[thumbID]);
            } else {
                viewerMsg.text = "contents type : " + typeList[thumbID];
                viewerMsg.appendText("\n イメージファイルではありません。 ");
                
                notImage();
            }
        }
         private function thumbnailClick(e:MouseEvent):void {
            var thumbID:int = e.currentTarget._id;
            if (typeList[thumbID] == "image/jpeg") {
                imageViewer(urlList[thumbID]);
            } else {
                viewerMsg.text = "contents type : " + typeList[thumbID];
                viewerMsg.appendText("\n イメージファイルではありません。 ");
                notImage();
            }
        }
        private var back:Sprite;
        private var backAlpha:Number;
        private var count:int;
        private var circles:Shape;
        private var thumbMsg:TextField;
        private function thumbLoadInit():void {
            back = new Sprite();
            back.graphics.beginFill(0x000000);
            back.graphics.drawRect(0, 0, 465, 465);
            back.mouseEnabled = false;
            addChild(back);
            
            circles = new Shape();
            addChild(circles);
            circles.x = 465 * 0.5;
            circles.y = 465 * 0.5;
            
            thumbMsg = new TextField();
            thumbMsg.mouseEnabled = false;
            var tf:TextFormat = new TextFormat();
            tf.align = "center";
            thumbMsg.defaultTextFormat = tf;
            thumbMsg.text = "";
            thumbMsg.width = 240;
            thumbMsg.height = 120;
            thumbMsg.x = 465 * 0.5 - thumbMsg.width * 0.5;
            thumbMsg.y = 220;
            thumbMsg.textColor = 0xFFFFFF;
            thumbMsg.selectable = false;
            thumbMsg.type = TextFieldType.DYNAMIC;
            back.addChild(thumbMsg);
        }
        private function thumbLoadStart():void {
            circles.visible = true;
            count = 0;
            back.visible = true;
            back.mouseEnabled = true;
            
            removeEventListener(Event.ENTER_FRAME, thumbLoaderFadeOut);
            addEventListener(Event.ENTER_FRAME, thumbLoaderFadeIn);
            addEventListener(Event.ENTER_FRAME, loadingGimmick);
        }
        private function thumbLoadFinish():void {
            circles.visible = false;
            back.mouseEnabled = false;
            
            removeEventListener(Event.ENTER_FRAME, thumbLoaderFadeIn);
            addEventListener(Event.ENTER_FRAME, thumbLoaderFadeOut);
            removeEventListener(Event.ENTER_FRAME, loadingGimmick);
        }
        private function thumbLoaderFadeIn(e:Event = null):void {
            backAlpha += 0.1;
            if (backAlpha > 1) {
                backAlpha = 1;
                removeEventListener(Event.ENTER_FRAME, thumbLoaderFadeIn);
            }
            back.alpha = backAlpha;
        }
        private function thumbLoaderFadeOut(e:Event = null):void {
            backAlpha -= 0.01;
            if (backAlpha < 0) {
                backAlpha = 0;
                back.visible = false;
                removeEventListener(Event.ENTER_FRAME, thumbLoaderFadeOut);
            }
            back.alpha = backAlpha;
        }
        private function thumbLoadIOError():void {
            circles.visible = false;
            thumbMsg.text = "規定数のファイルが見つかりません。\n";
            thumbMsg.appendText("キーワードを変えて検索してください。");
            
            urlList = [];
            typeList = [];
            urlList = urlList.concat(urlListBackup);
            typeList = typeList.concat(typeListBackup);
            
            back.mouseEnabled = true;
            back.buttonMode = true;
            back.addEventListener(MouseEvent.CLICK, thumbIOErrorProcess);
            removeEventListener(Event.ENTER_FRAME, loadingGimmick);
        }
        private function thumbIOErrorProcess(e:MouseEvent):void {
            thumbMsg.text = "";
            back.mouseEnabled = false;
            back.buttonMode = false;
            back.removeEventListener(MouseEvent.CLICK, thumbIOErrorProcess);
            addEventListener(Event.ENTER_FRAME, thumbLoaderFadeOut);
            addEventListener(Event.ENTER_FRAME, update);
        }
        private function loadingGimmick(e:Event = null):void {
            circles.graphics.clear();
            for (var i:int = 0; i < 8; i++) {
                if ( count % 8 == i) {
                    circles.graphics.beginFill(0xDDDDDD);
                } else {
                    circles.graphics.beginFill(0x666666);
                }
                circles.graphics.drawCircle(Math.cos(i * 0.785398) * 12, Math.sin(i * 0.785398) * 12, 2);
            }
            count += 1;
        }
        
        private var viewer:Sprite;
        private var viewerBitmap:Bitmap;
        private var viewerAlpha:Number;
        private var viewerMsg:TextField;
        private function viewerInit():void {
            viewer = new Sprite();
            viewer.visible = false;
            
            viewer.buttonMode = true;
            viewer.addEventListener(MouseEvent.CLICK, viewerClose);
            
            viewer.addChild(new Bitmap(new BitmapData(465, 465, true, 0x99000000)));
            viewerBitmap = new Bitmap(new BitmapData(1, 1, true, 0x00000000));
            viewer.addChild(viewerBitmap);
            addChild(viewer);
            
            viewerMsg = new TextField();
            viewerMsg.mouseEnabled = false;
            var tf:TextFormat = new TextFormat();
            tf.align = "center";
            viewerMsg.defaultTextFormat = tf;
            viewerMsg.text = "";
            viewerMsg.width = 240;
            viewerMsg.height = 120;
            viewerMsg.x = 465 * 0.5 - viewerMsg.width * 0.5;
            viewerMsg.y = 220;
            viewerMsg.textColor = 0xFFFFFF;
            viewerMsg.selectable = false;
            viewerMsg.type = TextFieldType.DYNAMIC;
            viewer.addChild(viewerMsg);
        }
        private var imgLoader:Loader;
        private function imageViewer(url:String):void {
            viewerMsg.text = "";
            viewer.buttonMode = true;
            viewer.addEventListener(MouseEvent.CLICK, viewerClose);
            imgLoader = new Loader();
            imgLoader.load(new URLRequest(url + "?=" + Math.random()), new LoaderContext(true));
            imgLoader.contentLoaderInfo.addEventListener(Event.INIT, init);
            imgLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioerror);
            
            viewer.removeChild(viewerBitmap);
            viewerBitmap.alpha = viewerAlpha = 0;
            viewerLoadStart();
            
            function init(e:Event):void {
                var ratio:Number =  imgLoader.width / imgLoader.height;
                if (ratio >= 1) {
                    var scale:Number = 465 / imgLoader.width;
                    var bmd:BitmapData = new BitmapData(465, 465 / ratio , true, 0x00000000);
                } else {
                    scale = 465 / imgLoader.height;
                    bmd = new BitmapData(465 * ratio, 465 , true, 0x00000000);
                }
                viewerBitmap = new Bitmap(bmd, "auto", false);
                
                viewerBitmap.x = (465 * 0.5 - bmd.width * 0.5);
                viewerBitmap.y = (465 * 0.5 - bmd.height * 0.5);
                bmd.draw(imgLoader.content, new Matrix(scale, 0, 0, scale));
                
                viewerBitmap.visible = true;
                viewer.addChild(viewerBitmap);
                viewerLoadFinish();
                imgLoader.unload();
            }
            function ioerror(e:Event):void {
                viewerMsg.text = "読み込みに失敗しました。";
                
                viewerBitmap.visible = true;
                viewerBitmap = new Bitmap(new BitmapData(1, 1, true, 0x00000000));
                viewerLoadFinish();
                imgLoader.unload();
            }
        }
        private function notImage():void {
            viewer.buttonMode = true;
            viewer.addEventListener(MouseEvent.CLICK, viewerClose);
            
            imgLoader = new Loader();
            viewer.removeChild(viewerBitmap);
            viewerBitmap.alpha = viewerAlpha = 0;
            viewerLoadStart();
            
            viewerBitmap = new Bitmap(new BitmapData(1, 1, true, 0x00000000));
            viewer.addChild(viewerBitmap);
            
            viewerLoadFinish();
        }
        private function viewLoaderFadeIn(e:Event = null):void {
            viewerAlpha += 0.08;
            if (viewerAlpha > 1) {
                viewerAlpha = 1;
                removeEventListener(Event.ENTER_FRAME, viewLoaderFadeIn);
            }
            viewer.alpha = viewerAlpha;
        }
        private function viewLoaderFadeOut(e:Event = null):void {
            viewerAlpha -= 0.08;
            if (viewerAlpha < 0) {
                viewerAlpha = 0;
                viewer.visible = false;
                removeEventListener(Event.ENTER_FRAME, viewLoaderFadeOut);
            }
            viewer.alpha = viewerAlpha;
        }
        private function viewerLoadStart():void {
            circles.visible = true;
            count = 0;
            viewer.visible = true;
            
            addEventListener(Event.ENTER_FRAME, viewLoaderFadeIn);
            addEventListener(Event.ENTER_FRAME, loadingGimmick);
            removeEventListener(Event.ENTER_FRAME, update);
        }
        private function viewerLoadFinish():void {
            circles.visible = false;
            removeEventListener(Event.ENTER_FRAME, loadingGimmick);
        }
        private function viewerClose(e:Event = null):void {
            imgLoader.unload();
            viewer.buttonMode = false;
            
            if (!viewer.contains(viewerBitmap)) {
                viewerBitmap = new Bitmap(new BitmapData(1, 1, true, 0x00000000));
                viewer.addChild(viewerBitmap);
            }
            
            viewer.removeEventListener(MouseEvent.CLICK, viewerClose);
            viewer.alpha = viewerAlpha = 1;
            addEventListener(Event.ENTER_FRAME, viewLoaderFadeOut);
            addEventListener(Event.ENTER_FRAME, update);
            circles.visible = false;
            removeEventListener(Event.ENTER_FRAME, loadingGimmick);
        }
        
        private var keyword:String  = "kurashiki";
        private var searchTF:TextField;
        private function controlPanel():void {
            //
            var tf:TextFormat = new TextFormat();
            searchTF = new TextField();
            searchTF.text = keyword;
            searchTF.width = 160;
            searchTF.height = 18;
            searchTF.x = 215;
            searchTF.y = 10;
            searchTF.border = true;
            searchTF.textColor = 0x000000;
            searchTF.borderColor = 0x666666;
            searchTF.background = true;
            searchTF.backgroundColor = 0xFFFFFF
            searchTF.type = TextFieldType.INPUT;
            searchTF.addEventListener(KeyboardEvent.KEY_UP, onKeyUpHandler);
            addChild(searchTF);
            //
            var searchButton:Sprite = new Sprite();
            searchButton.buttonMode = true;
            searchButton.addEventListener(MouseEvent.CLICK, searchButtonClick);
            searchButton.x = 385;
            searchButton.y = 10;
            addChild(searchButton);
            var searchButtonTF:TextField = new TextField();
            searchButtonTF.mouseEnabled = false;
            tf.align = "center";
            searchButtonTF.defaultTextFormat = tf;
            searchButtonTF.text = "search";
            searchButtonTF.width = 60;
            searchButtonTF.height = 18;
            searchButtonTF.border = true;
            searchButtonTF.textColor = 0xFFFFFF;
            searchButtonTF.borderColor = 0x666666;
            searchButtonTF.background = true;
            searchButtonTF.selectable = false;
            searchButtonTF.backgroundColor = 0x000000;
            searchButtonTF.type = TextFieldType.DYNAMIC;
            searchButton.addChild(searchButtonTF);
            //
            var thumbButton:Sprite = new Sprite();
            //thumbButton.buttonMode = true;
            thumbButton.addEventListener(MouseEvent.MOUSE_OVER, thumbButtonClick);
            thumbButton.x = 20;
            thumbButton.y = 10;
            addChild(thumbButton);
            var thumbButtonTF:TextField = new TextField();
            thumbButtonTF.mouseEnabled = false;
            tf.align = "center";
            thumbButtonTF.defaultTextFormat = tf;
            thumbButtonTF.text = "thumbnail";
            thumbButtonTF.width = 80;
            thumbButtonTF.height = 18;
            thumbButtonTF.border = true;
            thumbButtonTF.textColor = 0xFFFFFF;
            thumbButtonTF.borderColor = 0x666666;
            thumbButtonTF.background = true;
            thumbButtonTF.selectable = false;
            thumbButtonTF.backgroundColor = 0x000000;
            thumbButtonTF.type = TextFieldType.DYNAMIC;
            thumbButton.addChild(thumbButtonTF);
        }
        private function searchButtonClick(e:MouseEvent):void {
            if (searchTF.text != "" && searchTF.text != keyword) {
                keyword = searchTF.text;
                MediaRSSReader();
                back.visible = true;
                back.alpha = backAlpha = 0;
                thumbLoadStart();
            }
        }
        private function onKeyUpHandler(e:KeyboardEvent):void {
            if (e.keyCode == 13 && e.currentTarget.text != "" && searchTF.text != keyword) {
                keyword = e.currentTarget.text;
                MediaRSSReader();
                back.visible = true;
                back.alpha = backAlpha = 0;
                thumbLoadStart();
            }
        }
        private var isLock:Boolean = false;
        private function thumbButtonClick(e:MouseEvent):void {
            Tweener.addTween(thumbContainer, { y : 40, time : 0.7, transition : "easeInOutCubic"});
            //
            addEventListener(Event.ENTER_FRAME, mouseObserver);
        }
        private function mouseObserver(e:Event):void {
            if (stage.mouseY > 160) {
                Tweener.addTween(thumbContainer, { y : -110, time : 0.7, transition : "easeInOutCubic"});
                removeEventListener(Event.ENTER_FRAME, mouseObserver);
            }
        }
    }
}

import flash.display.Sprite;
class Thumbnail extends Sprite {
    public var _id:int
    public function Thumbnail(id:int) {
        _id = id
    }
}

import flash.geom.Vector3D;
class Polygon {
    public var c:Number = 0;
    public var x:Number = 0;
    public var y:Number = 0;
    public var z:Number = 0;
    public var i0:int = 0;
    public var i1:int = 0;
    public var i2:int = 0;
    public var u0:Number = 0;
    public var u1:Number = 0;
    public var u2:Number = 0;
    public var v0:Number = 0;
    public var v1:Number = 0;
    public var v2:Number = 0;
    public function Polygon(i0:int, i1:int, i2:int, u0:Number, v0:Number, u1:Number, v1:Number, u2:Number, v2:Number) {
        this.i0 = i0;
        this.i1 = i1;
        this.i2 = i2;
        this.u0 = u0;
        this.v0 = v0;
        this.u1 = u1;
        this.v1 = v1;
        this.u2 = u2;
        this.v2 = v2;
    }
}

import flash.display.Sprite;
import flash.geom.Vector3D;
class Tourou  extends Sprite {
    public var id:int;
    public var collisionCheck:Boolean;
    public var registId:int = 0;
    public var c:Number = 0;
    public var px:Number;
    public var py:Number;
    public var pz:Number;
    public var vx:Number;
    //public var vy:Number;
    public var vz:Number;
    //public var rx:Number;
    public var ry:Number = Math.random() * 360;
    //public var rz:Number;
    //public var tx:Number = Math.random() * 2 - 1;
    public var ty:Number = Math.random() * 2 - 1;
    //public var tz:Number = Math.random() * 2 - 1;
    public var radius:Number;
    public var v3Ds:Vector.<Vector3D> = new Vector.<Vector3D>();
    public var vertices:Vector.<Number> = new Vector.<Number>();
    //public var worldVertices:Vector.<Number> = new Vector.<Number>();
    public var cameraVertices:Vector.<Number> = new Vector.<Number>();
    public var indices:Vector.<int> = new Vector.<int>();
    public var uvts:Vector.<Number> = new Vector.<Number>();
    
    private var _u0:Number;
    private var _u1:Number;
    private var _v0:Number;
    private var _v1:Number;
    
    public var polygonList:Vector.<Polygon> = new Vector.<Polygon>();
    public function Tourou(u0:Number = 0.0, u1:Number = 0.0, v0:Number = 0.1, v1:Number = 0.1) {
        _u0 = u0;
        _u1 = u1;
        _v0 = v0;
        _v1 = v1;
        init();
    }
    private function init():void {
        const w:int = 20;
        const h:int = -40;
        
        const tw:int = 26;
        const uw:int = 23;
        const h2:int = -4;
        
        v3Ds.push(new Vector3D(0, 0, 0));
        
        v3Ds.push(new Vector3D( -w, h + h2, -w));
        v3Ds.push(new Vector3D( -w, 0 + h2, -w));
        v3Ds.push(new Vector3D(w, h + h2, -w));
        v3Ds.push(new Vector3D(w, 0 + h2, -w));
        v3Ds.push(new Vector3D(w, h + h2, w));
        v3Ds.push(new Vector3D(w, 0 + h2, w));
        v3Ds.push(new Vector3D(-w, h + h2, w));
        v3Ds.push(new Vector3D( -w, 0 + h2, w));
        
        v3Ds.push(new Vector3D(0, 0 + h2, -w));
        v3Ds.push(new Vector3D(0, 0 + h2, w));
        
        //
        indices.push(1, 9, 2);
        indices.push(1, 3, 9);
        indices.push(3, 4, 9);
        indices.push(3, 5, 6);
        indices.push(3, 6, 4);
        indices.push(5, 10, 6);
        indices.push(5, 7, 10);
        indices.push(7, 8, 10);
        indices.push(7, 1, 2);
        indices.push(7, 2, 8);
        //
        indices.push(1, 4, 3);
        indices.push(1, 2, 4);
        indices.push(3, 6, 5);
        indices.push(3, 4, 6);
        indices.push(5, 8, 7);
        indices.push(5, 6, 8);
        indices.push(7, 2, 1);
        indices.push(7, 8, 2);
        
        var _um:Number = _u0 + (_u1 - _u0) * 0.5;
        //
        uvts.push(_u0, _v0, null, _um, _v1, null, _u0, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v0, null, _um, _v1, null);
        uvts.push(_u1, _v0, null, _u1, _v1, null, _um, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v0, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u0, _v1, null);
        uvts.push(_u0, _v0, null, _um, _v1, null, _u0, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v0, null, _um, _v1, null);
        uvts.push(_u1, _v0, null, _u1, _v1, null, _um, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v0, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u0, _v1, null);
        //
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        
        //--
        v3Ds.push(new Vector3D( -tw, h2, -tw));
        v3Ds.push(new Vector3D( -uw, 0, -uw));
        v3Ds.push(new Vector3D(tw, h2, -tw));
        v3Ds.push(new Vector3D(uw, 0, -uw));
        v3Ds.push(new Vector3D(tw, h2, tw));
        v3Ds.push(new Vector3D(uw, 0, uw));
        v3Ds.push(new Vector3D(-tw, h2, tw));
        v3Ds.push(new Vector3D(-uw, 0, uw));
        
        //
        indices.push(11, 13, 14);
        indices.push(11, 14, 12);
        indices.push(13, 15, 16);
        indices.push(13, 16, 14);
        indices.push(15, 17, 18);
        indices.push(15, 18, 16);
        indices.push(17, 11, 12);
        indices.push(17, 12, 18);
        indices.push(11, 15, 13);
        indices.push(11, 17, 15);

        var du0:Number = 0.52;
        var du1:Number = 0.58;
        var dv0:Number = 0.52;
        var dv1:Number = 0.58;
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        
        var len:int = v3Ds.length;
        for (var i:int = 0; i < len; i++) {
            vertices.push(v3Ds[i].x);
            vertices.push(v3Ds[i].y);
            vertices.push(v3Ds[i].z);
        }
        
        radius = Math.sqrt((w * w) * 2);
        
        len = indices.length;
        for (i = 0; i < len; i++) {
            if (i % 3 == 0) {
                var tmp:Polygon = new Polygon(
                    indices[i],
                    indices[i + 1 >> 0],
                    indices[i + 2 >> 0],
                    
                    uvts[i * 3 + 0 >> 0], uvts[i * 3 + 1 >> 0],
                    uvts[i * 3 + 3 >> 0], uvts[i * 3 + 4 >> 0],
                    uvts[i * 3 + 6 >> 0], uvts[i * 3 + 7 >> 0]
                );
                polygonList.push(tmp);
            }
        }
    }
}

import flash.geom.Vector3D;
class Kyouzou {
    public var collisionCheck:Boolean;
    public var registId:int = 0;
    public var c:Number = 0;
    public var px:Number;
    public var py:Number;
    public var pz:Number;
    public var vx:Number;
    //public var vy:Number;
    public var vz:Number;
    //public var rx:Number;
    public var ry:Number = Math.random() * 360;
    //public var rz:Number;
    //public var tx:Number = Math.random() * 2 - 1;
    public var ty:Number = Math.random() * 2 - 1;
    //public var tz:Number = Math.random() * 2 - 1;
    public var hitArea:Number;
    public var v3Ds:Vector.<Vector3D> = new Vector.<Vector3D>();
    public var vertices:Vector.<Number> = new Vector.<Number>();
    //public var worldVertices:Vector.<Number> = new Vector.<Number>();
    public var cameraVertices:Vector.<Number> = new Vector.<Number>();
    public var indices:Vector.<int> = new Vector.<int>();
    public var uvts:Vector.<Number> = new Vector.<Number>();
    
    public var polygonList:Vector.<Polygon> = new Vector.<Polygon>();
    private var _u0:Number;
    private var _u1:Number;
    private var _v0:Number;
    private var _v1:Number;
    
    public function Kyouzou(u0:Number = 0.0, u1:Number = 0.0, v0:Number = 0.1, v1:Number = 0.1) {
        _u0 = u0;
        _u1 = u1;
        _v0 = v0;
        _v1 = v1;
        init();
    }
    private function init():void {
        const w:int = 20;
        const h:int = 32;
        
        const tw:int = 26;
        const uw:int = 23;
        const h2:int = 4;
        
        v3Ds.push(new Vector3D(0, 0, 0));
        v3Ds.push(new Vector3D( -w, h + h2, -w));
        v3Ds.push(new Vector3D( -w, 0 + h2, -w));
        v3Ds.push(new Vector3D(w, h + h2, -w));
        v3Ds.push(new Vector3D(w, 0 + h2, -w));
        v3Ds.push(new Vector3D(w, h + h2, w));
        v3Ds.push(new Vector3D(w, 0 + h2, w));
        v3Ds.push(new Vector3D(-w, h + h2, w));
        v3Ds.push(new Vector3D(-w, 0 + h2, w));
        indices.push(1, 4, 3);
        indices.push(1, 2, 4);
        indices.push(3, 6, 5);
        indices.push(3, 4, 6);
        indices.push(5, 8, 7);
        indices.push(5, 6, 8);
        indices.push(7, 2, 1);
        indices.push(7, 8, 2);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        uvts.push(_u0, _v0, null, _u1, _v1, null, _u1, _v0, null);
        uvts.push(_u0, _v0, null, _u0, _v1, null, _u1, _v1, null);
        
        //
        v3Ds.push(new Vector3D( -tw, h2, -tw));
        v3Ds.push(new Vector3D( -uw, 0, -uw));
        v3Ds.push(new Vector3D(tw, h2, -tw));
        v3Ds.push(new Vector3D(uw, 0, -uw));
        v3Ds.push(new Vector3D(tw, h2, tw));
        v3Ds.push(new Vector3D(uw, 0, uw));
        v3Ds.push(new Vector3D(-tw, h2, tw));
        v3Ds.push(new Vector3D(-uw, 0, uw));
        
        //
        indices.push(9, 12, 11);
        indices.push(9, 10, 12);
        indices.push(11, 14, 13);
        indices.push(11, 12, 14);
        indices.push(13, 16, 15);
        indices.push(13, 14, 16);
        indices.push(15, 10, 9);
        indices.push(15, 16, 10);
        var du0:Number = 0.52;
        var du1:Number = 0.58;
        var dv0:Number = 0.52;
        var dv1:Number = 0.58;
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        uvts.push(du0, dv0, null, du1, dv0, null, du1, dv1, null);
        uvts.push(du0, dv0, null, du1, dv1, null, du0, dv1, null);
        
        var len:int = v3Ds.length;
        for (var i:int = 0; i < len; i++) {
            vertices.push(v3Ds[i].x);
            vertices.push(v3Ds[i].y);
            vertices.push(v3Ds[i].z);
        }
        
        hitArea = Math.sqrt((w * w) * 2);
        
        len = indices.length;
        for (i = 0; i < len; i++) {
            if (i % 3 == 0) {
                var tmp:Polygon = new Polygon(
                    indices[i],
                    indices[i + 1 >> 0],
                    indices[i + 2 >> 0],
                    
                    uvts[i * 3 + 0 >> 0], uvts[i * 3 + 1 >> 0],
                    uvts[i * 3 + 3 >> 0], uvts[i * 3 + 4 >> 0],
                    uvts[i * 3 + 6 >> 0], uvts[i * 3 + 7 >> 0]
                );
                polygonList.push(tmp);
            }
        }
    }
}

import flash.geom.Vector3D;
class Minamo {
    public var collisionCheck:Boolean;
    public var c:Number = 0;
    public var px:Number = 0;
    public var py:Number = 0;
    public var pz:Number = 0;
    public var vx:Number  = 0;
    public var vz:Number = 0;
    public var ry:Number = 0;

    public var v3Ds:Vector.<Vector3D> = new Vector.<Vector3D>();
    public var vertices:Vector.<Number> = new Vector.<Number>();
    //public var worldVertices:Vector.<Number> = new Vector.<Number>();
    public var cameraVertices:Vector.<Number> = new Vector.<Number>();
    public var indices:Vector.<int> = new Vector.<int>();
    public var uvts:Vector.<Number> = new Vector.<Number>();
    
    public var polygonList:Vector.<Polygon> = new Vector.<Polygon>();
    public function Minamo() {
        init();
    }
    private function init():void {
        const r:int = 1200;
        const l:int = -1200;
        const c:int = 0;
        
        const t:int = 1200;
        const u:int = -600;
        const z:int = 0;
        
        indices.push(0, 1, 2);
        v3Ds.push(new Vector3D(l, 0, t));
        v3Ds.push(new Vector3D(c, 0, t));
        v3Ds.push(new Vector3D(c, 0, z));
        indices.push(3, 4, 5);
        v3Ds.push(new Vector3D(l, 0, t));
        v3Ds.push(new Vector3D(c, 0, z));
        v3Ds.push(new Vector3D(l, 0, z));
        indices.push(6, 7, 8);
        v3Ds.push(new Vector3D(c, 0, t));
        v3Ds.push(new Vector3D(r, 0, t));
        v3Ds.push(new Vector3D(r, 0, z));
        indices.push(9, 10, 11);
        v3Ds.push(new Vector3D(c, 0, t));
        v3Ds.push(new Vector3D(r, 0, z));
        v3Ds.push(new Vector3D(c, 0, z));
        indices.push(12, 13, 14);
        v3Ds.push(new Vector3D(l, 0, z));
        v3Ds.push(new Vector3D(c, 0, z));
        v3Ds.push(new Vector3D(c, 0, u));
        indices.push(15, 16, 17);
        v3Ds.push(new Vector3D(l, 0, z));
        v3Ds.push(new Vector3D(c, 0, u));
        v3Ds.push(new Vector3D(l, 0, u));
        indices.push(18, 19, 20);
        v3Ds.push(new Vector3D(c, 0, z));
        v3Ds.push(new Vector3D(r, 0, z));
        v3Ds.push(new Vector3D(r, 0, u));
        indices.push(0, 1, 4);
        v3Ds.push(new Vector3D(c, 0, z));
        v3Ds.push(new Vector3D(r, 0, u));
        v3Ds.push(new Vector3D(c, 0, u));
        
        var u0:Number = 0.0;
        var u1:Number = 0.25;
        var u2:Number = 0.5;
        var v0:Number = 0.51;
        var v1:Number = 0.75;
        var v2:Number = 1.0;
        //
        uvts.push(u0, v0, null, u1, v0, null, u1, v1, null);
        uvts.push(u0, v0, null, u1, v1, null, u0, v1, null);
        uvts.push(u1, v0, null, u2, v0, null, u2, v1, null);
        uvts.push(u1, v0, null, u2, v1, null, u1, v1, null);
        uvts.push(u0, v1, null, u1, v1, null, u1, v2, null);
        uvts.push(u0, v1, null, u1, v2, null, u0, v2, null);
        uvts.push(u1, v1, null, u2, v1, null, u2, v2, null);
        uvts.push(u1, v1, null, u2, v2, null, u1, v2, null);
        
        var len:int = v3Ds.length;
        for (var i:int = 0; i < len; i++) {
            vertices.push(v3Ds[i].x);
            vertices.push(v3Ds[i].y);
            vertices.push(v3Ds[i].z);
        }
        len = indices.length;
        for (i = 0; i < len; i++) {
            if (i % 3 == 0) {
                var tmp:Polygon = new Polygon(
                    indices[i],
                    indices[i + 1 >> 0],
                    indices[i + 2 >> 0],
                    
                    uvts[i * 3 + 0 >> 0], uvts[i * 3 + 1 >> 0],
                    uvts[i * 3 + 3 >> 0], uvts[i * 3 + 4 >> 0],
                    uvts[i * 3 + 6 >> 0], uvts[i * 3 + 7 >> 0]
                );
                polygonList.push(tmp);
            }
        }
    }
}